//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "math.h"

#include "mainfrm.h"
/********************** set-up of include pathes ****************************
Please note: you have to set up the pathes to the include files before
this sample program can be compiled:
Use the command "Project/Options", select the "Directories/Conditional"
tab, and add the required packages to the "include path"

example:
   if you installed the packages into the default directory, the
   include path for the BasePack will be: "C:\SDLSuite\basepack\C6"

More information can be found in the following FAQ article:
   http://forum.sdlsuite.com/read.php?f=2&i=21&t=21
*****************************************************************************/
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SDL_NumIO"
#pragma link "SDL_NumLab"
#pragma link "SDL_polchart"
#pragma resource "*.dfm"
TFrmPolChart *FrmPolChart;
//---------------------------------------------------------------------------
__fastcall TFrmPolChart::TFrmPolChart(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TFrmPolChart::DrawData()
{
int i;

PC->ClearGraf();
PC->RangeLow = 0;
PC->RangeHigh = 10;
PC->DataColor = clRed;
PC->MoveTo(0,0);
PC->LineWidth = 1;
for (i=1; i<=1000; i++)
  {
  PC->DrawTo (i/100.0,i/50.0);
  }
PC->DataColor = clBlue;
PC->TransparentItems = true;
PC->LineWidth = 1;
i = PC->AddTextLabel (6, 210, clBlue, "This is a text label", 0);
PC->TextLabels[i]->AttachToData = true;
PC->TextLabels[i]->Mode = tlShadow;
PC->TextLabels[i]->ShadowDx = 3;
PC->TextLabels[i]->ShadowDy = 6;
PC->ShowGraf();
}
//---------------------------------------------------------------------------


void __fastcall TFrmPolChart::SBarMagChange(TObject *Sender)
{
PC->MagFactor = 1.0*SBarMag->Position/100;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::SBarRangeHighChange(TObject *Sender)
{
PC->RangeHigh = SBarRangeHigh->Position/10;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::SBarRangeLowChange(TObject *Sender)
{
PC->RangeLow = SBarRangeLow->Position/10;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::NIORayAngleChange(TObject *Sender)
{
PC->AngleBtwRays = ceil(NIORayAngle->Value);
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::SBarAngleOffsChange(TObject *Sender)
{
if (PC->UseDegrees)
  {
  PC->AngleOffset = SBarAngleOffs->Position;
  }
else
  {
  PC->AngleOffset = SBarAngleOffs->Position/180.0*M_PI;
  }
NLabAngleOffs->Value = PC->AngleOffset;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::RGAngLabelModeClick(TObject *Sender)
{
PC->LabelModeAngular = TpcAngLabelMode (RGAngLabelMode->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::RGUseDegClick(TObject *Sender)
{
PC->UseDegrees = (RGUseDeg->ItemIndex == 0);
if (PC->UseDegrees)
  {
  NLabAngleOffs->Precision = 0;
  NLabAngleOffs->RightText = "deg";
  PC->AngleOffset = SBarAngleOffs->Position;
  PC->LabelModeAngular = almDegrees;
  RGAngLabelMode->ItemIndex = almDegrees;
  }
else
  {
  NLabAngleOffs->Precision = 2;
  NLabAngleOffs->RightText = "rad";
  PC->AngleOffset = SBarAngleOffs->Position/180*M_PI;
  PC->LabelModeAngular = almRadians;
  RGAngLabelMode->ItemIndex = almRadians;
  }
NLabAngleOffs->Value = PC->AngleOffset;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::RGRotDirClick(TObject *Sender)
{
if (RGRotDir->ItemIndex == 0)
  {
  PC->RotationDir = rdClockwise;
  }
else
  {
  PC->RotationDir = rdCounterCW;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::FormShow(TObject *Sender)
{
DrawData();
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::PCZoomPan(TObject *Sender)
{
SBarMag->Position = ceil(PC->MagFactor*100.0);
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::PCMouseMoveInChart(TObject *Sender, bool InChart,
      TShiftState Shift, double rad, double phi)
{
NLabRad->Value = rad;
NLabPhi->Value = phi;
if (RGCrossHair->ItemIndex > 0)
  {
  PC->CrossHair1->SetPosition (rad, phi);
  }
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::Pan1Click(TObject *Sender)
{
PC->MouseAction = maPan;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::Reset1Click(TObject *Sender)
{
PC->UseDegrees = true;
NLabAngleOffs->Precision = 0;
NLabAngleOffs->RightText = "deg";
PC->AngleOffset = SBarAngleOffs->Position;
PC->LabelModeAngular = almDegrees;
RGAngLabelMode->ItemIndex = almDegrees;
NLabAngleOffs->Value = PC->AngleOffset;
PC->MagFactor = 0.7;
PC->AngleOffset = 0;
PC->AngleBtwRays = 30;
PC->RangeLow = 0;
PC->RangeHigh = 10;
PC->CenterChart();
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::Zoom1Click(TObject *Sender)
{
PC->MouseAction = maZoomDrag;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::DragLabels1Click(TObject *Sender)
{
PC->MouseAction = maDragLabel;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::PopMenNoMouseActClick(TObject *Sender)
{
PC->MouseAction = Sdl_sdlbase::maNone;
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::PCBeforeDrawScaleLabel(TObject *Sender,
      TCanvas *&Canvas, TpcScaleKind ScaleType,
      AnsiString &CurrentTickLabel, int ChartX, int ChartY)
{
if (ScaleType == sckRad)
  {
  CurrentTickLabel = CurrentTickLabel + EdUnitsRad->Text;
  }
else
  {
  CurrentTickLabel = CurrentTickLabel + EdUnitsAng->Text;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::RGCrossHairClick(TObject *Sender)
{
PC->CrossHair1->Mode = TpcCrossHMode(RGCrossHair->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::RGRadLabelsClick(TObject *Sender)
{
PC->LabelModeRadial = TpcRadLabelMode (RGRadLabels->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::RGGridRadClick(TObject *Sender)
{
PC->GridStyleRadial = TpcGridStyleRad(RGGridRad->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::RGGridAngClick(TObject *Sender)
{
PC->GridStyleAngular = TpcGridStyleAng(RGGridAng->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TFrmPolChart::EdUnitsAngChange(TObject *Sender)
{
PC->ShowGraf();
}
//---------------------------------------------------------------------------
